﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Dicide.ViewModels
{
    public class WireViewModel : ConductorViewModel
    {
        public override void UpdateHasConnectors()
        {
            if (Rotation == 0 || Rotation == 180)
            {
                HasLeftConnector = true;
                HasTopConnector = false;
                HasRightConnector = true;
                HasBottomConnector = false;
            }
            else
            {
                HasLeftConnector = false;
                HasTopConnector = true;
                HasRightConnector = false;
                HasBottomConnector = true;
            }
        }

        protected override IEnumerable<ConductorViewModel> NeighboringConductors()
        {
            var left = Left as ConductorViewModel;
            var top = Top as ConductorViewModel;
            var right = Right as ConductorViewModel;
            var bottom = Bottom as ConductorViewModel;

            if (Rotation == 0 || Rotation == 180)
            {
                top = null;
                bottom = null;
            }
            else
            {
                left = null;
                right = null;
            }

            if (left != null && left.HasRightConnector) yield return left;
            if (top != null && top.HasBottomConnector) yield return top;
            if (right != null && right.HasLeftConnector) yield return right;
            if (bottom != null && bottom.HasTopConnector) yield return bottom;
        }
    }
}
